#ifndef __BOOST__IO__FORMAT_OBJECTS__ARRAY_OUTPUT__HPP
#define __BOOST__IO__FORMAT_OBJECTS__ARRAY_OUTPUT__HPP
   namespace boost { namespace io
   {
      template< typename FormatType, typename Outputter = boost::io::basic_output >
      class array_output: public detail::list_output< FormatType, array_output, Outputter >
      {
         private:
            long                       length;
            long                       offset;
         public:
            template< typename T, class OutputStream >
            inline OutputStream &                operator()
                                                 (
                                                    OutputStream & os,
                                                    const T * array
                                                 ) const
            {
               return( detail::list_output< FormatType, array_output, Outputter >::operator()
               (
                  os, array + offset, array + offset + length
               ));
            }
         public:
            inline array_output &                operator()( long len )
            {
               length = len;
               offset = 0;
               return( *this );
            }
            inline array_output &                operator()( long off, long len )
            {
               length = len;
               offset = off;
               return( *this );
            }
         public:
            inline                     array_output( long len = 0 ) throw():
               length( len ),
               offset( 0 )
            {
            }
            inline                     array_output( long off, long len ) throw():
               length( len ),
               offset( off )
            {
            }
            inline                     array_output( Outputter o ) throw():
               detail::list_output< FormatType, array_output, Outputter >( o ),
               length( 0 ),
               offset( 0 )
            {
            }
            inline                     array_output( const array_output & const o ) throw():
               detail::list_output< FormatType, array_output, Outputter >( o ),
               length( o.length ),
               offset( o.offset )
            {
            }
            template< typename RT2 >
            inline           array_output
                             (
                                const formatter_t< FormatType, RT2 > & const fmt
                             ) throw():
               detail::list_output< FormatType, array_output, Outputter >( fmt )
            {
            }
      };
   }}
#endif
