#ifndef __BOOST__IO__FORMATTER__IPP
#define __BOOST__IO__FORMATTER__IPP
   // format control
   
   template< typename FormatType, class ReferenceType >
   boost::io::formatter_t< FormatType, ReferenceType >::listfmt_type
   boost::io::formatter_t< FormatType, ReferenceType >::openlist() const throw()
   {
      return( __openlist );
   }
   template< typename FormatType, class ReferenceType >
   boost::io::formatter_t< FormatType, ReferenceType >::listfmt_type
   boost::io::formatter_t< FormatType, ReferenceType >::closelist() const throw()
   {
      return( __closelist );
   }
   template< typename FormatType, class ReferenceType >
   boost::io::formatter_t< FormatType, ReferenceType >::listfmt_type
   boost::io::formatter_t< FormatType, ReferenceType >::separator() const throw()
   {
      return( __separator );
   }

   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::format
   (
      listfmt_type ol,
      listfmt_type cl,
      listfmt_type s
   ) throw()
   {
      __openlist  = ol;
      __closelist = cl;
      __separator = s;
      return( *static_cast< ReferenceType * >( this ));
   }
   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::format
   (
      listfmt_type ol,
      listfmt_type cl
   ) throw()
   {
      __openlist  = ol;
      __closelist = cl;
      return( *static_cast< ReferenceType * >( this ));
   }
   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::format
   (
      listfmt_type s
   ) throw()
   {
      __separator = s;
      return( *static_cast< ReferenceType * >( this ));
   }

   // spacing control

   template< typename FormatType, class ReferenceType >
   bool boost::io::formatter_t< FormatType, ReferenceType >::spaceBeforeSep() const throw()
   {
      return( __spaceBeforeSep );
   }
   template< typename FormatType, class ReferenceType >
   bool boost::io::formatter_t< FormatType, ReferenceType >::spaceAfterSep() const throw()
   {
      return( __spaceAfterSep );
   }
   template< typename FormatType, class ReferenceType >
   bool boost::io::formatter_t< FormatType, ReferenceType >::spaceAroundList() const throw()
   {
      return( __spaceAroundList );
   }

   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::space
   (
      bool bs,
      bool as,
      bool al
   ) throw()
   {
      __spaceBeforeSep  = bs;
      __spaceAfterSep   = as;
      __spaceAroundList = al;
      return( *static_cast< ReferenceType * >( this ));
   }
   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::space
   (
      bool bs,
      bool as
   ) throw()
   {
      __spaceBeforeSep  = bs;
      __spaceAfterSep   = as;
      return( *static_cast< ReferenceType * >( this ));
   }
   template< typename FormatType, class ReferenceType >
   ReferenceType & boost::io::formatter_t< FormatType, ReferenceType >::space
   (
      bool al
   ) throw()
   {
      __spaceAroundList = al;
      return( *static_cast< ReferenceType * >( this ));
   }

   // constructors

   template< typename FormatType, class ReferenceType >
   boost::io::formatter_t< FormatType, ReferenceType >::formatter_t() throw():
      __openlist(  traits_type::open_default      ),
      __closelist( traits_type::close_default     ),
      __separator( traits_type::seperator_default ),
      __spaceBeforeSep(  false ),
      __spaceAfterSep(   true  ),
      __spaceAroundList( true  )
   {
   }

   // boost::io::formatter

   template< typename FormatType >
   boost::io::formatter< FormatType >::formatter() throw(): formatter_t< FormatType, formatter >()
   {
   }
#endif
